/**
 *
 * Created by Kyle Benk kylebenkapps.com
 *
 * 12/13
 */

jQuery(document).ready(function($) {

	// Iconpicker

	$('button[role="iconpicker"]').iconpicker().iconpicker('setCols', 10).iconpicker('setRows', 5);

	// Tabs

	$('#myTab a').click(function (e) {
	  e.preventDefault();
	  $(this).tab('show');
	})
	$('#myTab a:first').tab('show');

	// Color Picker

	$('.color_input').wpColorPicker();

	// Tooltips

	//$('[data-toggle="tooltip"]').tooltip();

	// Image

	$('#' + wps_pf_data.prefix_dash + 'image-btn').click(function(e) {
	    e.preventDefault();

		var custom_uploader = wp.media()

	    .on('select', function() {
	        var attachment = custom_uploader.state().get('selection').first().toJSON();
	        $('#' + wps_pf_data.prefix_dash + 'image-show').css('background-image', 'url(' + attachment.url + ')');
	        $('#' + wps_pf_data.prefix_dash + 'image').val(attachment.id);
	    })
	    .open();
	});

	$('#' + wps_pf_data.prefix_dash + 'image-btn-remove').click(function(){
		$('#' + wps_pf_data.prefix_dash + 'image-show').css('background-image', '');
	    $('#' + wps_pf_data.prefix_dash + 'image').val('');
	});

	// Background Image

	$('#' + wps_pf_data.prefix_dash + 'background-image-btn').click(function(e) {
	    e.preventDefault();

		var custom_uploader = wp.media()

	    .on('select', function() {
	        var attachment = custom_uploader.state().get('selection').first().toJSON();
	        $('#' + wps_pf_data.prefix_dash + 'background-image-show').css('background-image', 'url(' + attachment.url + ')');
	        $('#' + wps_pf_data.prefix_dash + 'background-image').val(attachment.id);
	    })
	    .open();
	});

	$('#' + wps_pf_data.prefix_dash + 'background-image-btn-remove').click(function(){
		$('#' + wps_pf_data.prefix_dash + 'background-image-show').css('background-image', '');
	    $('#' + wps_pf_data.prefix_dash + 'background-image').val('');
	});

	// Background Type

	$("." + wps_pf_data.prefix_dash + "background-type").hide();
	$("." + wps_pf_data.prefix_dash + "background-type-" + $("select[name='" + wps_pf_data.prefix_dash + "background-type']").val()).show();

 	$("select[name='" + wps_pf_data.prefix_dash + "background-type']").change(function() {
 		$("." + wps_pf_data.prefix_dash + "background-type").hide();
 		$("." + wps_pf_data.prefix_dash + "background-type-" + $(this).val()).show();
	});

	// Datetimepicker

	$('#' + wps_pf_data.prefix_dash + 'start-datepicker').datetimepicker({
        format: 'MM/DD/YYYY'
    });

	$('#' + wps_pf_data.prefix_dash + 'end-datepicker').datetimepicker({
        format: 'MM/DD/YYYY'
    });

	$('#' + wps_pf_data.prefix_dash + 'end-datepicker')
		.data("DateTimePicker")
		.minDate( $('#' + wps_pf_data.prefix_dash + 'start-datepicker').data("DateTimePicker").date() );

	$('#' + wps_pf_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
       $('#' + wps_pf_data.prefix_dash + 'end-datepicker').data("DateTimePicker").minDate(e.date);
    });

    $('#' + wps_pf_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
       $('#' + wps_pf_data.prefix_dash + 'start-datepicker').data("DateTimePicker").maxDate(e.date);
    });

    /**
	 *
	 * Real-time validation for required fields
	 *
	 */

	$("#" + wps_pf_data.prefix_dash + "name").keyup(function(){
		if ($(this).val() != '') {
			$(this).parent('div').parent('div').removeClass('has-error has-feedback');
			$(this).parent('div').find('.glyphicon-remove').remove();
		} else {
			$(this).parent('div').parent('div').addClass('has-error has-feedback');
			$(this).parent('div').append('<span class="glyphicon glyphicon-remove form-control-feedback"></span>');
		}
	});

	// Form submit preventDefault() if required values are not satisfied

	$("#" + wps_pf_data.prefix_dash + "form").submit(function(e){

		if ($("#" + wps_pf_data.prefix_dash + "name").val() == '') {
			e.preventDefault();
		}
	});

	var newsletter_templates = ['2', '3', '6', '9', '10', '11', '12'];

	$("." + wps_pf_data.prefix_dash + "template").hide();
	$("." + wps_pf_data.prefix_dash + "template-" + $("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val()).show();

 	$("input[name='" + wps_pf_data.prefix_dash + "template-type']").change(function() {

 		$("." + wps_pf_data.prefix_dash + "template").hide();
 		$("." + wps_pf_data.prefix_dash + "template-" + $(this).val()).show();

 		// Show and Hide Newsletter settings

 		$('.' + wps_pf_data.prefix_dash + 'news-letter-WordPress-div').hide();
 		$('.' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-getresponse-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-madmimi-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-feedburner-div').hide();

	  	if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'WordPress' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
			$('.' + wps_pf_data.prefix_dash + 'news-letter-WordPress-div').show();
	  	}

	  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'MailChimp' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
			$('.' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-div').show();
	  	}

	  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'aweber' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-div').show();
	  	}

	  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'getresponse' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-getresponse-div').show();
	  	}

	  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'campaignmonitor' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-div').show();
	  	}

	  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'madmimi' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-madmimi-div').show();
	  	}

	  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'feedburner' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-feedburner-div').show();
	  	}
	});

	// Trigger Type

	$("." + wps_pf_data.prefix_dash + "trigger-args-type").hide();
	$("." + wps_pf_data.prefix_dash + "trigger-args-type-" + $("select[name='" + wps_pf_data.prefix_dash + "trigger-args-type']").val()).show();

 	$("select[name='" + wps_pf_data.prefix_dash + "trigger-args-type']").change(function() {
 		$("." + wps_pf_data.prefix_dash + "trigger-args-type").hide();
 		$("." + wps_pf_data.prefix_dash + "trigger-args-type-" + $(this).val()).show();
	});

  	// Newsletter

  	$('#' + wps_pf_data.prefix_dash + 'news-letter-type').change(function() {
	  	$('.' + wps_pf_data.prefix_dash + 'news-letter-WordPress-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-getresponse-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-madmimi-div').hide();
		$('.' + wps_pf_data.prefix_dash + 'news-letter-feedburner-div').hide();


	  	if ($(this).val() == 'WordPress' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
			$('.' + wps_pf_data.prefix_dash + 'news-letter-WordPress-div').show();
	  	}

	  	else if ($(this).val() == 'MailChimp' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
			$('.' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-div').show();
	  	}

	  	else if ($(this).val() == 'aweber' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-div').show();
	  	}

	  	else if ($(this).val() == 'getresponse' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-getresponse-div').show();
	  	}

	  	else if ($(this).val() == 'campaignmonitor' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-div').show();
	  	}

	  	else if ($(this).val() == 'madmimi' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-madmimi-div').show();
	  	}

	  	else if ($(this).val() == 'feedburner' &&
	  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {
		  	$('.' + wps_pf_data.prefix_dash + 'news-letter-feedburner-div').show();
	  	}
	});

	$('.' + wps_pf_data.prefix_dash + 'news-letter-WordPress-div').hide();
	$('.' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-div').hide();
	$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-div').hide();
	$('.' + wps_pf_data.prefix_dash + 'news-letter-getresponse-div').hide();
	$('.' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-div').hide();
	$('.' + wps_pf_data.prefix_dash + 'news-letter-madmimi-div').hide();
	$('.' + wps_pf_data.prefix_dash + 'news-letter-feedburner-div').hide();

  	if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'WordPress' &&
  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

		$('.' + wps_pf_data.prefix_dash + 'news-letter-WordPress-div').show();
  	}

  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'MailChimp' &&
  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

		$('.' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-div').show();
  	}

  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'aweber' &&
  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

	  	$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-div').show();
  	}

  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'getresponse' &&
  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

	  	$('.' + wps_pf_data.prefix_dash + 'news-letter-getresponse-div').show();
  	}

  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'campaignmonitor' &&
  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

	  	$('.' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-div').show();
  	}

  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'madmimi' &&
  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

	  	$('.' + wps_pf_data.prefix_dash + 'news-letter-madmimi-div').show();
  	}

  	else if ($('#' + wps_pf_data.prefix_dash + 'news-letter-type').val() == 'feedburner' &&
  		$.inArray($("input[name='" + wps_pf_data.prefix_dash + "template-type']:checked").val(), newsletter_templates) != -1) {

	  	$('.' + wps_pf_data.prefix_dash + 'news-letter-feedburner-div').show();
  	}

  	// Success Action

	$("." + wps_pf_data.prefix_dash + "news-letter-success-action").hide();
	$("." + wps_pf_data.prefix_dash + "news-letter-success-action-" + $("#" + wps_pf_data.prefix_dash + "news-letter-success-action").val()).show();

 	$("#" + wps_pf_data.prefix_dash + "news-letter-success-action").change(function() {
 		$("." + wps_pf_data.prefix_dash + "news-letter-success-action").hide();
 		$("." + wps_pf_data.prefix_dash + "news-letter-success-action-" + $(this).val()).show();

 	});

  	if (typeof(wps_pf_data.post_types) != "undefined" && wps_pf_data.post_types !== null) {

	  	// Trigger

		$('#' + wps_pf_data.prefix_dash + 'trigger-display-on').change(function(){
			for (var i = 0; i < wps_pf_data.post_types.length; i++) {
				$('#' + wps_pf_data.prefix_dash + 'trigger-div-' + wps_pf_data.post_types[i]).hide();
			}
			$('#' + wps_pf_data.prefix_dash + 'trigger-category-div').hide();
			$('#' + wps_pf_data.prefix_dash + 'trigger-tag-div').hide();


		  	if($(this).val() == 'category') {
			  	$('#' + wps_pf_data.prefix_dash + 'trigger-category-div').show();
		  	}else if($(this).val() == 'tag') {
			  	$('#' + wps_pf_data.prefix_dash + 'trigger-tag-div').show();
		  	}else {
			  	for (var i = 0; i < wps_pf_data.post_types.length; i++) {
			  		if($(this).val() == wps_pf_data.post_types[i]) {
				  		$('#' + wps_pf_data.prefix_dash + 'trigger-div-' + wps_pf_data.post_types[i]).show();
				  	}
				}
		  	}
		});

		for (var i = 0; i < wps_pf_data.post_types.length; i++) {
			$('#' + wps_pf_data.prefix_dash + 'trigger-div-' + wps_pf_data.post_types[i]).hide();
		}

		$('#' + wps_pf_data.prefix_dash + 'trigger-category-div').hide();
		$('#' + wps_pf_data.prefix_dash + 'trigger-tag-div').hide();

		if ($('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val() == 'category') {
		  	$('#' + wps_pf_data.prefix_dash + 'trigger-category-div').show();
	  	}

	  	else if ($('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val() == 'tag') {
		  	$('#' + wps_pf_data.prefix_dash + 'trigger-tag-div').show();
	  	}

	  	else {

		  	for (var i = 0; i < wps_pf_data.post_types.length; i++) {
		  		if ($('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val() == wps_pf_data.post_types[i]) {
			  		$('#' + wps_pf_data.prefix_dash + 'trigger-div-' + wps_pf_data.post_types[i]).show();
			  	}
			}
	  	}

	  	// Post Types

	  	for (var i = 0; i < wps_pf_data.post_types.length; i++) {

			$('#' + wps_pf_data.prefix_dash + 'trigger-all-' + wps_pf_data.post_types[i]).click(function() {
				if($(this).is(':checked')) {
					$('#' + wps_pf_data.prefix_dash + 'trigger-id-div-' + $(this).attr('data-post')).hide();
				}else{
					$('#' + wps_pf_data.prefix_dash + 'trigger-id-div-' + $(this).attr('data-post')).show();
				}
			});

			if($('#' + wps_pf_data.prefix_dash + 'trigger-all-' + wps_pf_data.post_types[i]).is(':checked')) {
				$('#' + wps_pf_data.prefix_dash + 'trigger-id-div-' + wps_pf_data.post_types[i]).hide();
			}
		}
  	}

  	// Google Fonts Toogle

  	$('.bfh-googlefonts').hide();
  	$('#' + wps_pf_data.prefix_dash + 'font-family-heading').hide();
  	$('#' + wps_pf_data.prefix_dash + 'font-family').hide();

	if ($('#' + wps_pf_data.prefix_dash + 'google-fonts').prop('checked')) {

		$('#' + wps_pf_data.prefix_dash + 'google-font-heading').insertAfter($('#' + wps_pf_data.prefix_dash + 'font-family-heading'));
		$('#' + wps_pf_data.prefix_dash + 'google-font').insertAfter($('#' + wps_pf_data.prefix_dash + 'font-family'));

		$('.bfh-googlefonts').show();

	} else {

		$('#' + wps_pf_data.prefix_dash + 'font-family-heading').insertAfter($('#' + wps_pf_data.prefix_dash + 'google-font-heading'));
		$('#' + wps_pf_data.prefix_dash + 'font-family').insertAfter($('#' + wps_pf_data.prefix_dash + 'google-font'));

		$('#' + wps_pf_data.prefix_dash + 'font-family-heading').show();
		$('#' + wps_pf_data.prefix_dash + 'font-family').show();
	}

  	$('#' + wps_pf_data.prefix_dash + 'google-fonts').change(function(){

	  	$('.bfh-googlefonts').hide();
	  	$('#' + wps_pf_data.prefix_dash + 'font-family-heading').hide();
	  	$('#' + wps_pf_data.prefix_dash + 'font-family').hide();

  		if ($(this).prop('checked')) {

  			$('#' + wps_pf_data.prefix_dash + 'google-font-heading').insertAfter($('#' + wps_pf_data.prefix_dash + 'font-family-heading'));
  			$('#' + wps_pf_data.prefix_dash + 'google-font').insertAfter($('#' + wps_pf_data.prefix_dash + 'font-family'));

  			$('.bfh-googlefonts').show();

  		} else {

  			$('#' + wps_pf_data.prefix_dash + 'font-family-heading').insertAfter($('#' + wps_pf_data.prefix_dash + 'google-font-heading'));
  			$('#' + wps_pf_data.prefix_dash + 'font-family').insertAfter($('#' + wps_pf_data.prefix_dash + 'google-font'));

  			$('#' + wps_pf_data.prefix_dash + 'font-family-heading').show();
  			$('#' + wps_pf_data.prefix_dash + 'font-family').show();
  		}
  	});

	// Category

	$('#' + wps_pf_data.prefix_dash + 'trigger-category-all').click(function() {
		if($(this).is(':checked')) {
			$('#' + wps_pf_data.prefix_dash + 'trigger-category-id-div').hide();
		}else{
			$('#' + wps_pf_data.prefix_dash + 'trigger-category-id-div').show();
		}
	});

	if($('#' + wps_pf_data.prefix_dash + 'trigger-category-all').is(':checked')) {
		$('#' + wps_pf_data.prefix_dash + 'trigger-category-id-div').hide();
	}

	// User Roles

	$("." + wps_pf_data.prefix_dash + "trigger-args-users").hide();
	$("." + wps_pf_data.prefix_dash + "trigger-args-users-" + $("#" + wps_pf_data.prefix_dash + "trigger-args-users").val()).show();

 	$("#" + wps_pf_data.prefix_dash + "trigger-args-users").change(function() {
 		$("." + wps_pf_data.prefix_dash + "trigger-args-users").hide();
 		$("." + wps_pf_data.prefix_dash + "trigger-args-users-" + $(this).val()).show();

 	});

 	// URL Referrer

	$("." + wps_pf_data.prefix_dash + "trigger-args-referrer").hide();
	$("." + wps_pf_data.prefix_dash + "trigger-args-referrer-" + $("#" + wps_pf_data.prefix_dash + "trigger-args-referrer-type").val()).show();

 	$("#" + wps_pf_data.prefix_dash + "trigger-args-referrer-type").change(function() {
 		$("." + wps_pf_data.prefix_dash + "trigger-args-referrer").hide();
 		$("." + wps_pf_data.prefix_dash + "trigger-args-referrer-" + $(this).val()).show();

 	});

 	// Link button

 	$("#" + wps_pf_data.prefix_dash + "template-args-link-type").change(function(){

	 	$("." + wps_pf_data.prefix_dash + "template-args-link-button-color").hide();

 		if ($(this).val() == 'button') {
 			$("." + wps_pf_data.prefix_dash + "template-args-link-button-color").show();
 		}

 	});

 	$("." + wps_pf_data.prefix_dash + "template-args-link-button-color").hide();

	if ($("#" + wps_pf_data.prefix_dash + "template-args-link-type").val() == 'button') {
		$("." + wps_pf_data.prefix_dash + "template-args-link-button-color").show();
	}

	// Get all MailChimp Lists

	$('#' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_pf_data.prefix_dash + 'MailChimp-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_pf_data.prefix_dash + 'MailChimp-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-MailChimp-list');

		var data = {
			'action': 'wps_pf_get_mailchimp_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-api-key').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {
			$('#' + wps_pf_data.prefix_dash +'MailChimp-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-MailChimp-list').html(response);
		});
	});

	// Get Aweber Lists

	$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-connect').click(function(){
		$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-code').parent('div').parent('div').removeClass('hidden');
		$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-code').removeClass('hidden');
	});

	$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-code').keyup(function (){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_pf_data.prefix_dash + 'aweber-get-lists-spinner').length != 0) {
			return;
		}

		// Do nothing if the user did not input a code

		if ($('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-code').val() == '') {
			return;
		}

		$('#' + wps_pf_data.prefix_dash +'news-letter-aweber-list-id').html('');

		$('<i id="' + wps_pf_data.prefix_dash + 'aweber-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-aweber-list-id');

		var data = {
			'action': 'wps_pf_get_aweber_lists',
			'consumer_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-consumer-key').val(),
			'consumer_secret': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(),
			'access_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-access-key').val(),
			'access_secret': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-access-secret').val(),
			'code': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-code').val(),
			'popup_id': getUrlParameter('popup_id')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {

			response = $.parseJSON(response);

			$('#' + wps_pf_data.prefix_dash +'aweber-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-aweber-list-id').html(response.html);

			$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-consumer-key').val(response.consumer_key);
			$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(response.consumer_secret);
			$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-access-key').val(response.access_key);
			$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-access-secret').val(response.access_secret);

			if (response.consumer_key != '') {
				$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-code').addClass('hidden');
			}

		});
	});

	// Get all Get Response Lists

	$('#' + wps_pf_data.prefix_dash + 'news-letter-getresponse-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_pf_data.prefix_dash + 'getresponse-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_pf_data.prefix_dash + 'getresponse-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-getresponse-campaign');

		var data = {
			'action': 'wps_pf_get_getresponse_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-getresponse-api-key').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {
			$('#' + wps_pf_data.prefix_dash +'getresponse-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-getresponse-campaign').html(response);
		});
	});

	// Get all Campaign Monitor Clients and Lists

	$('#' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('.' + wps_pf_data.prefix_dash + 'campaignmonitor-get-lists-spinner').length != 0) {
			return;
		}

		$('<i class="' + wps_pf_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-list');
		$('<i class="' + wps_pf_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-client');

		var data = {
			'action': 'wps_pf_get_campaignmonitor_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-api-key').val(),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {

			response = $.parseJSON(response);

			$('.' + wps_pf_data.prefix_dash +'campaignmonitor-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-client').html(response.clients);
			$('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-list').html(response.lists);

		});
	});

	// Update lists for Campaign Monitor

	$('#' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-client').change(function(){

		// Do nothing if we are already retrieve the lists

		if ($('.' + wps_pf_data.prefix_dash + 'campaignmonitor-get-lists-spinner').length != 0) {
			return;
		}

		$('<i class="' + wps_pf_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-list');

		var data = {
			'action': 'wps_pf_update_campaignmonitor_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-api-key').val(),
			'client_id': $(this).val(),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {
			$('.' + wps_pf_data.prefix_dash +'campaignmonitor-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-list').html(response);
		});
	});

	// Get all Mad Mimi Lists

	$('#' + wps_pf_data.prefix_dash + 'news-letter-madmimi-api-key').keyup(function(){

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_pf_data.prefix_dash + 'madmimi-get-lists-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_pf_data.prefix_dash + 'madmimi-get-lists-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-madmimi-list');

		var data = {
			'action': 'wps_pf_get_madmimi_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-madmimi-api-key').val(),
			'username': $('#' + wps_pf_data.prefix_dash + 'news-letter-madmimi-username').val(),
			'list': $('#' + wps_pf_data.prefix_dash +'news-letter-madmimi-list').val()
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {
			$('#' + wps_pf_data.prefix_dash +'madmimi-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-madmimi-list').html(response);
		});
	});

	// Async functions

	setTimeout(function() {

		// MailChimp

		$('<i id="' + wps_pf_data.prefix_dash + 'MailChimp-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-MailChimp-list');

		var data = {
			'action': 'wps_pf_get_mailchimp_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-api-key').val(),
			'list': $('#' + wps_pf_data.prefix_dash + 'news-letter-MailChimp-list').attr('data-list'),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {
			$('#' + wps_pf_data.prefix_dash +'MailChimp-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-MailChimp-list').html(response);
		});

		// Aweber

		$('#' + wps_pf_data.prefix_dash +'news-letter-aweber-list-id').html('');

		$('<i id="' + wps_pf_data.prefix_dash + 'aweber-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-aweber-list-id');

		var data = {
			'action': 'wps_pf_get_aweber_lists',
			'consumer_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-consumer-key').val(),
			'consumer_secret': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(),
			'access_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-access-key').val(),
			'access_secret': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-access-secret').val(),
			'code': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-code').val(),
			'optin_fire_id': getUrlParameter('optin_fire_id'),
			'list': $('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-list-id').attr('data-list'),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {

			response = $.parseJSON(response);

			$('#' + wps_pf_data.prefix_dash +'aweber-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-aweber-list-id').html(response.html);

			$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-consumer-key').val(response.consumer_key);
			$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(response.consumer_secret);
			$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-access-key').val(response.access_key);
			$('#' + wps_pf_data.prefix_dash + 'news-letter-aweber-access-secret').val(response.access_secret);

			if (response.consumer_key != '') {
				$('.' + wps_pf_data.prefix_dash + 'news-letter-aweber-code').addClass('hidden');
			}

		});

		// Get Response

		$('<i id="' + wps_pf_data.prefix_dash + 'getresponse-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-getresponse-campaign');

		var data = {
			'action': 'wps_pf_get_getresponse_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-getresponse-api-key').val(),
			'campaign': $('#' + wps_pf_data.prefix_dash + 'news-letter-getresponse-campaign').attr('data-campaign')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {
			$('#' + wps_pf_data.prefix_dash +'getresponse-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-getresponse-campaign').html(response);
		});

		// Campaign Monitor

		$('<i class="' + wps_pf_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>')
				.insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-list');
		$('<i class="' + wps_pf_data.prefix_dash + 'campaignmonitor-get-lists-spinner fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-client');

		var data = {
			'action': 'wps_pf_get_campaignmonitor_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-api-key').val(),
			'client': $('#' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-client').attr('data-client'),
			'list': $('#' + wps_pf_data.prefix_dash + 'news-letter-campaignmonitor-list').attr('data-list'),
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {

			response = $.parseJSON(response);

			$('.' + wps_pf_data.prefix_dash +'campaignmonitor-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-client').html(response.clients);
			$('#' + wps_pf_data.prefix_dash +'news-letter-campaignmonitor-list').html(response.lists);

		});

		// Mad Mimi

		$('<i id="' + wps_pf_data.prefix_dash + 'madmimi-get-lists-spinner" class="fa fa-spinner fa-spin"></i>')
			.insertAfter('#' + wps_pf_data.prefix_dash +'news-letter-madmimi-list');

		var data = {
			'action': 'wps_pf_get_madmimi_lists',
			'api_key': $('#' + wps_pf_data.prefix_dash + 'news-letter-madmimi-api-key').val(),
			'username': $('#' + wps_pf_data.prefix_dash + 'news-letter-madmimi-username').val(),
			'list': $('#' + wps_pf_data.prefix_dash +'news-letter-madmimi-list').attr('data-list')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		$.post(wps_pf_data.ajaxurl, data, function(response) {
			$('#' + wps_pf_data.prefix_dash +'madmimi-get-lists-spinner').remove();
			$('#' + wps_pf_data.prefix_dash +'news-letter-madmimi-list').html(response);
		});

	  	// Create an easy interface for selecting categories

		$.post(wps_pf_data.ajaxurl, {'action': 'wps_pf_get_categories'}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var tag_options = [];

		  	$.each(response, function( index, value ) {
			  	tag_options.push( {id: value.term_id, name: value.name} );
			});

		  	$('#' + wps_pf_data.prefix_dash + 'trigger-category-id').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});
		});

	   	// Create an easy interface for selecting tags

		$.post(wps_pf_data.ajaxurl, {'action': 'wps_pf_get_tags'}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var tag_options = [];

		  	$.each(response, function( index, value ) {
			  	tag_options.push( {id: value.term_id, name: value.name} );
			});

		  	$('#' + wps_pf_data.prefix_dash + 'trigger-tag-id').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});

		  	$('#' + wps_pf_data.prefix_dash + 'recent-posts-tag').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});
		});

		if ($('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val() != 'site' ||
			$('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val() != 'category' ||
			$('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val() != 'tag' ||
			$('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val() != 'archive') {

			$.post(wps_pf_data.ajaxurl, {'action': 'wps_pf_get_posts', 'post_type': $('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val()}, function(response) {

				response = $.parseJSON(response);

				// Create an easy interface for selecting tags

			  	var post_options = [];

			  	$.each(response, function( index, value ) {
				  	post_options.push({id: value.ID, name: value.post_title});

				});

				// Include Posts

				$('.' + wps_pf_data.prefix_dash + 'trigger-id-' + $('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val()).selectize({
				  	plugins: ['remove_button'],
				  	valueField: 'id',
					labelField: 'name',
					searchField: 'name',
				  	options: post_options,
			  	});
			});
		}
	} ,1);

	// Upon Display On setting chnage refresh the selectize options if needed

	$('#' + wps_pf_data.prefix_dash + 'trigger-display-on').change(function() {

		if ($(this).val() != 'site' || $(this).val() != 'category' || $(this).val() != 'tag' || $(this).val() != 'archive') {

			$.post(wps_pf_data.ajaxurl, {'action': 'wps_pf_get_posts', 'post_type': $(this).val()}, function(response) {

				response = $.parseJSON(response);

				// Create an easy interface for selecting tags

			  	var post_options = [];

			  	$.each(response, function( index, value ) {
				  	post_options.push({id: value.ID, name: value.post_title});

				});

				// Include posts

				if (!$('.' + wps_pf_data.prefix_dash + 'trigger-id-' + $('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val()).hasClass('selectized')) {
					$('.' + wps_pf_data.prefix_dash + 'trigger-id-' + $('#' + wps_pf_data.prefix_dash + 'trigger-display-on').val()).selectize({
					  	plugins: ['remove_button'],
					  	valueField: 'id',
						labelField: 'name',
						searchField: 'name',
					  	options: post_options,
				  	});
				}
			});
		}
	});

	// Populate all Exclude post selectize on load

	$('#' + wps_pf_data.prefix_dash + 'trigger-display-on option').each(function() {

		$.post(wps_pf_data.ajaxurl, {'action': 'wps_pf_get_posts', 'post_type': $(this).val()}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var post_options = [];
		  	var post_type = '';

		  	$.each(response, function( index, value ) {
			  	post_options.push({id: value.ID, name: value.post_title});
			  	post_type = value.post_type;
			});

			// Exclude posts

			$('.' + wps_pf_data.prefix_dash + 'trigger-exclude-' + post_type).selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: post_options,
		  	});
		});
	});

	// Add selectize to the Referrer Domains

	var referrer_options = [
		{id: 't.co'},
		{id: 'www.facebook.com'},
		{id: 'plus.url.google.com'},
		{id: 'www.linkedin.com'},
	];

	var temp_referrer_options = $('#' + wps_pf_data.prefix_dash + 'trigger-args-referrer').attr('data-urls').split(',');

	$.each(temp_referrer_options, function( index, value ) {
	  	referrer_options.push({id: value});
	});

	$('#' + wps_pf_data.prefix_dash + 'trigger-args-referrer').selectize({
		plugins: ['remove_button'],
		create: true,
		valueField: 'id',
		labelField: 'id',
		searchField: 'id',
		options: referrer_options,
	});

	// Clear all caches from this popup

	$('.' + wps_pf_data.prefix_dash + 'clear-cache').click(function(e) {

		e.preventDefault();

		// Do nothing if we are already retrieve the lists

		if ($('#' + wps_pf_data.prefix_dash + 'clear-cache-spinner').length != 0) {
			return;
		}

		$('<i id="' + wps_pf_data.prefix_dash + 'clear-cache-spinner" class="fa fa-spinner fa-spin"></i>').insertAfter('.' + wps_pf_data.prefix_dash + 'clear-cache');


		$.post(wps_pf_data.ajaxurl, {'action': 'wps_pf_clear_cache', 'popup_id': getUrlParameter('popup_id')}, function(response) {
			console.log(response);
			$('#' + wps_pf_data.prefix_dash +'clear-cache-spinner').remove();
		});

	});

	function getUrlParameter(sParam) {
	    var sPageURL = window.location.search.substring(1);
	    var sURLVariables = sPageURL.split('&');
	    for (var i = 0; i < sURLVariables.length; i++)
	    {
	        var sParameterName = sURLVariables[i].split('=');
	        if (sParameterName[0] == sParam)
	        {
	            return sParameterName[1];
	        }
	    }
	}
});